Public Class Form1
    Private BCR As New Opticon.Bcrctl.BarcodeReader
    Private BCD As New Opticon.Bcrctl.BarcodeDecoder

    Dim listView1 As New ListView
    Dim CodeID(4) As ListViewItem

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' BarcodeReader Setting Page Init
        If BCR.PowerOn Then
            checkBox_PowerOn.Checked = True
        Else
            checkBox_PowerOn.Checked = False
        End If

        Select Case BCR.TriggerKeySetting
            Case Opticon.Bcrctl.TriggerKey.DISABLED
                comboBox_TriggerKeySetting.SelectedIndex = 0
            Case Opticon.Bcrctl.TriggerKey.SIDE
                comboBox_TriggerKeySetting.SelectedIndex = 1
            Case Opticon.Bcrctl.TriggerKey.CENTER
                comboBox_TriggerKeySetting.SelectedIndex = 2
            Case Opticon.Bcrctl.TriggerKey.BOTH
                comboBox_TriggerKeySetting.SelectedIndex = 3
        End Select

        Select Case BCR.OutputMode
            Case Opticon.Bcrctl.DataOutput.BUFFER
                comboBox_OutputMode.SelectedIndex = 0
            Case Opticon.Bcrctl.DataOutput.KEYCODE
                comboBox_OutputMode.SelectedIndex = 1
            Case Opticon.Bcrctl.DataOutput.CLIPBOARD
                comboBox_OutputMode.SelectedIndex = 2
        End Select

        Select Case BCR.BuzzerVolume
            Case Opticon.Bcrctl.Volume.MUTE
                comboBox_BuzzerVolume.SelectedIndex = 0
            Case Opticon.Bcrctl.Volume.LOW
                comboBox_BuzzerVolume.SelectedIndex = 1
            Case Opticon.Bcrctl.Volume.MIDDLE
                comboBox_BuzzerVolume.SelectedIndex = 2
            Case Opticon.Bcrctl.Volume.HIGH
                comboBox_BuzzerVolume.SelectedIndex = 3
        End Select

        textBox_FilePath.Text = BCR.BeepFile.ToString()

        ' Decoder Setting Page Init
        If BCD.ReadMode = Opticon.Bcrctl.BCRReadMode.SINGLE Then
            radioButton_SingleMode.Checked = True
        Else
            radioButton_MultipleMode.Checked = True
        End If

        Select Case BCD.ReadTime
            Case Opticon.Bcrctl.BCRReadTime.ZERO_SEC
                comboBox_ReadTime.SelectedIndex = 0
            Case Opticon.Bcrctl.BCRReadTime.ONE_SEC
                comboBox_ReadTime.SelectedIndex = 1
            Case Opticon.Bcrctl.BCRReadTime.TWO_SEC
                comboBox_ReadTime.SelectedIndex = 2
            Case Opticon.Bcrctl.BCRReadTime.THREE_SEC
                comboBox_ReadTime.SelectedIndex = 3
            Case Opticon.Bcrctl.BCRReadTime.FOUR_SEC
                comboBox_ReadTime.SelectedIndex = 4
            Case Opticon.Bcrctl.BCRReadTime.FIVE_SEC
                comboBox_ReadTime.SelectedIndex = 5
            Case Opticon.Bcrctl.BCRReadTime.SIX_SEC
                comboBox_ReadTime.SelectedIndex = 6
            Case Opticon.Bcrctl.BCRReadTime.SEVEN_SEC
                comboBox_ReadTime.SelectedIndex = 7
            Case Opticon.Bcrctl.BCRReadTime.EIGHT_SEC
                comboBox_ReadTime.SelectedIndex = 8
            Case Opticon.Bcrctl.BCRReadTime.NINE_SEC
                comboBox_ReadTime.SelectedIndex = 9
            Case Opticon.Bcrctl.BCRReadTime.INDEFINITELY
                comboBox_ReadTime.SelectedIndex = 10
        End Select

        textBox_SuffixChar.Text = BCD.SuffixChar.ToString()

        Select Case BCD.NegativeSymbol
            Case Opticon.Bcrctl.BCRNegativeSymbol.Positive
                comboBox_NegativeBarcode.SelectedIndex = 0
            Case Opticon.Bcrctl.BCRNegativeSymbol.Negative
                comboBox_NegativeBarcode.SelectedIndex = 1
            Case Opticon.Bcrctl.BCRNegativeSymbol.Both
                comboBox_NegativeBarcode.SelectedIndex = 2
        End Select

        ' Readable Codes ListView Init
        ListViewInit()
    End Sub

    Private Sub ListViewInit()
        ' Create a new ListView control
        listView1 = New ListView()
        listView1.Bounds = New Rectangle(8, 110, 210, 95)

        ' Set the view to show details
        listView1.View = View.Details

        ' Display check boxes
        listView1.CheckBoxes = True
        ' Select the item and subitems when selection is made
        listView1.FullRowSelect = True

        '        Dim CodeID(4) As ListViewItem
        Dim readableCode As Long = BCD.ReadableCodes

        CodeID(0) = New ListViewItem("UPC")
        listView1.Items.Add(CodeID(0))
        If readableCode And Opticon.Bcrctl.CodeList.UPC <> 0 Then
            CodeID(0).Checked = True
        End If

        CodeID(1) = New ListViewItem("EAN(JAN)")
        listView1.Items.Add(CodeID(1))
        If readableCode And Opticon.Bcrctl.CodeList.EAN <> 0 Then
            CodeID(1).Checked = True
        End If

        CodeID(2) = New ListViewItem("DataMatrix(ECC200)")
        listView1.Items.Add(CodeID(2))
        If readableCode And Opticon.Bcrctl.CodeList.DataMatrixECC200 <> 0 Then
            CodeID(2).Checked = True
        End If

        CodeID(3) = New ListViewItem("QR Code")
        listView1.Items.Add(CodeID(3))
        If readableCode And Opticon.Bcrctl.CodeList.QRCode <> 0 Then
            CodeID(3).Checked = True
        End If

        listView1.Columns.Add("Click here to fix Readable Codes", -2, HorizontalAlignment.Left)
        TabPage2.Controls.Add(listView1)
        AddHandler listView1.ColumnClick, AddressOf listView1_ColumnClick
    End Sub

    Private Sub checkBox_PowerOn_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox_PowerOn.CheckStateChanged
        If checkBox_PowerOn.Checked Then
            BCR.PowerOn = True
        Else
            BCR.PowerOn = False
        End If
    End Sub

    Private Sub comboBox_TriggerKeySetting_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox_TriggerKeySetting.SelectedIndexChanged
        Select Case comboBox_TriggerKeySetting.SelectedIndex
            Case 0
                BCR.TriggerKeySetting = Opticon.Bcrctl.TriggerKey.DISABLED
            Case 1
                BCR.TriggerKeySetting = Opticon.Bcrctl.TriggerKey.SIDE
            Case 2
                BCR.TriggerKeySetting = Opticon.Bcrctl.TriggerKey.CENTER
            Case 3
                BCR.TriggerKeySetting = Opticon.Bcrctl.TriggerKey.BOTH
        End Select
    End Sub

    Private Sub comboBox_OutputMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox_OutputMode.SelectedIndexChanged
        Select Case comboBox_OutputMode.SelectedIndex
            Case 0
                BCR.OutputMode = Opticon.Bcrctl.DataOutput.BUFFER
            Case 1
                BCR.OutputMode = Opticon.Bcrctl.DataOutput.KEYCODE
            Case 2
                BCR.OutputMode = Opticon.Bcrctl.DataOutput.CLIPBOARD
        End Select
    End Sub

    Private Sub comboBox_BuzzerVolume_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox_BuzzerVolume.SelectedIndexChanged
        Select Case comboBox_BuzzerVolume.SelectedIndex
            Case 0
                BCR.BuzzerVolume = Opticon.Bcrctl.Volume.MUTE
            Case 1
                BCR.BuzzerVolume = Opticon.Bcrctl.Volume.LOW
            Case 2
                BCR.BuzzerVolume = Opticon.Bcrctl.Volume.MIDDLE
            Case 3
                BCR.BuzzerVolume = Opticon.Bcrctl.Volume.HIGH
        End Select
    End Sub

    Private Sub button_Browse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Browse.Click
        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim str As String
            Str = OpenFileDialog1.FileName.Substring(OpenFileDialog1.FileName.Length - 3)
            If str.CompareTo("wav") Then
                textBox_FilePath.Text = OpenFileDialog1.FileName
                BCR.BeepFile = textBox_FilePath.Text
            Else
                MessageBox.Show("It's an invalid file.")
            End If
        End If
    End Sub

    Private Sub listView1_ColumnClick(ByVal sender As Object, ByVal e As ColumnClickEventArgs)
        Dim readableCode As Long = BCD.ReadableCodes

        If CodeID(0).Checked Then
            readableCode = readableCode Or Opticon.Bcrctl.CodeList.UPC
        Else
            readableCode = readableCode And Not Opticon.Bcrctl.CodeList.UPC
        End If

        If CodeID(1).Checked Then
            readableCode = readableCode Or Opticon.Bcrctl.CodeList.EAN
        Else
            readableCode = readableCode And Not Opticon.Bcrctl.CodeList.EAN
        End If

        If CodeID(2).Checked Then
            readableCode = readableCode Or Opticon.Bcrctl.CodeList.DataMatrixECC200
        Else
            readableCode = readableCode And Not Opticon.Bcrctl.CodeList.DataMatrixECC200
        End If

        If CodeID(3).Checked Then
            readableCode = readableCode Or Opticon.Bcrctl.CodeList.QRCode
        Else
            readableCode = readableCode And Not Opticon.Bcrctl.CodeList.QRCode
        End If

        BCD.ReadableCodes = readableCode
    End Sub

    Private Sub radioButton_SingleMode_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioButton_SingleMode.CheckedChanged
        BCD.ReadMode = Opticon.Bcrctl.BCRReadMode.SINGLE
    End Sub

    Private Sub radioButton_MultipleMode_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioButton_MultipleMode.CheckedChanged
        BCD.ReadMode = Opticon.Bcrctl.BCRReadMode.MULTIPLE
    End Sub

    Private Sub comboBox_ReadTime_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox_ReadTime.SelectedIndexChanged
        Select Case comboBox_ReadTime.SelectedIndex
            Case 0
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.ZERO_SEC
            Case 1
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.ONE_SEC
            Case 2
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.TWO_SEC
            Case 3
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.THREE_SEC
            Case 4
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.FOUR_SEC
            Case 5
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.FIVE_SEC
            Case 6
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.SIX_SEC
            Case 7
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.SEVEN_SEC
            Case 8
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.EIGHT_SEC
            Case 9
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.NINE_SEC
            Case 10
                BCD.ReadTime = Opticon.Bcrctl.BCRReadTime.INDEFINITELY
        End Select
    End Sub

    Private Sub textBox_SuffixChar_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles textBox_SuffixChar.KeyDown
        If e.KeyCode = Keys.Enter Then
            BCD.SuffixChar = UInteger.Parse(textBox_SuffixChar.Text.ToString())
        End If
    End Sub

    Private Sub comboBox_NegativeBarcode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox_NegativeBarcode.SelectedIndexChanged
        Select Case comboBox_NegativeBarcode.SelectedIndex
            Case 0
                BCD.NegativeSymbol = Opticon.Bcrctl.BCRNegativeSymbol.Positive
            Case 1
                BCD.NegativeSymbol = Opticon.Bcrctl.BCRNegativeSymbol.Negative
            Case 2
                BCD.NegativeSymbol = Opticon.Bcrctl.BCRNegativeSymbol.Both
        End Select
    End Sub
End Class
